from re import compile
from os.path import getmtime

class AutoCompleteLaTeXSource:
	def __init__(self, wrapper):
		self.wrapper = wrapper
		self.filename = wrapper.get_filename()
		self.mtime = None
		self.packages = {}
	
	def get_break_chars(self):
		"""
		Return characters that break a word
		"""
		return "\n\t \\"
	
	def get_break_chars_retain(self):
		"""
		Return characters that break a word and must be retained
		"""
		return "\\"
	
	def query(self, prefix):
		if prefix[0] != "\\":
			return []
		
		prefix = prefix[1:]
		
		targets = self.wrapper.parser.get_targets()
		
		return [t for t in targets if str(t).startswith(prefix) and str(t) != prefix]
		
	def __file_changed(self):
		mtime = getmtime(self.filename)
		has_changed = (mtime != self.mtime)
		self.mtime = mtime
		return has_changed
	
	def __parse(self):
		packages = self.wrapper.parser.get_packages()
		
		curPackages = self.packages.keys()
		delPackages = list(set(curPackages).difference(packages))
		newPackages = list(set(packages).difference(curPackages))
		
		for p in delPackages:
			del self.packages[p]
		
		for p in newPackages:
			print "Adding LaTeX package %s" % p
			self.packages[p] = Package(p)
			
